//+------------------------------------------------------------------+
//|                                                                  |
//|                                                        FX Sniper |
//| Original Code by FX Sniper and just changed a little by Linuxser |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers     3
#property indicator_minimum    -0.10 
#property indicator_maximum    1.1
#property indicator_color1     Aqua 
#property  indicator_color2    LimeGreen
#property  indicator_color3    Red
#property indicator_levelcolor Red
#property indicator_level1     0.10
#property indicator_level2     0.90
//----
extern bool   LastBarOnly = false; 
extern int    HLR_Range   = 20;
extern int    T3_Period   = 10;
extern double b           = 1.00;
extern bool   Histogram   = false;
//----
double hlr[];
double hlrHup[];
double hlrHdn[];

double emas[][6];
double alpha;
double c1;
double c2;
double c3;
double c4;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(0, hlr);
    SetIndexBuffer(1, hlrHup);
    SetIndexBuffer(2, hlrHdn);
//----
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_HISTOGRAM);
    SetIndexStyle(2, DRAW_HISTOGRAM); 
//----        
    IndicatorShortName("HLR T3(" + HLR_Range + ", " + T3_Period + ")");
    SetIndexLabel(0, "HLR T3");     
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);   
//---- variable reset
   //
   //
   //
   //
   //
   
      double a  = b;
             c1 = -a*a*a;
             c2 =  3*(a*a+a*a*a);
             c3 = -3*(2*a*a+a+a*a*a);
             c4 = 1+3*a+a*a*a+3*a*a;

      T3_Period = MathMax(1,T3_Period);
      alpha = 2.0/(2.0 + (T3_Period-1.0)/2.0);

    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   int    pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
          
   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0; i--)
     {   
       hlr[i] = iT3(iCustom(NULL, 0,"HLR_v1a",LastBarOnly,HLR_Range,0,i),i);
       if(Histogram == true)
       {
         if(hlr[i] >= 0.50) hlrHup[i] = hlr[i];
         else            hlrHup[i]  = 0;   
         if(hlr[i] < 0.50 ) hlrHdn[i] = hlr[i];
         else            hlrHdn[i]  = 0; 
       }    
     }   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price,int shift)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0] = price;
         emas[i][1] = price;
         emas[i][2] = price;
         emas[i][3] = price;
         emas[i][4] = price;
         emas[i][5] = price;
      }
   else
      {
         emas[i][0] = emas[i-1][0]+alpha*(price     -emas[i-1][0]);
         emas[i][1] = emas[i-1][1]+alpha*(emas[i][0]-emas[i-1][1]);
         emas[i][2] = emas[i-1][2]+alpha*(emas[i][1]-emas[i-1][2]);
         emas[i][3] = emas[i-1][3]+alpha*(emas[i][2]-emas[i-1][3]);
         emas[i][4] = emas[i-1][4]+alpha*(emas[i][3]-emas[i-1][4]);
         emas[i][5] = emas[i-1][5]+alpha*(emas[i][4]-emas[i-1][5]);
      }
   return(c1*emas[i][5] + c2*emas[i][4] + c3*emas[i][3] + c4*emas[i][2]);
}